#ifndef __EMBEDED_TK_H__
#define __EMBEDED_TK_H__

#include <tcl.h>

// USAGE:
//
// Call Tcl_CreateInterp(), and pass the result of that to EmbededTkInit().
// then when ready, call CreateEmbededTkWindow(), with that same interp.
// The last two args specify where to return the name of the top level window.
//
// That window should be treated like a normal window.
//
// To add a button to that Tk window, you would do:
//
//     char name[1024];
//     char buf[1024];
//     sprintf(buf, "button %s.b; pack %s.b", name, name);
//     if (Tcl_Eval(interp, buf) != TCL_OK) {
//         fprintf(stderr, "eval err %s\n", Tcl_GetStringResult(interp));
//         return 0;
//     }

int EmbededTkInit(Tcl_Interp *);

HWND CreateEmbededTkWindow(Tcl_Interp *, DWORD dwStyle,
			   int x, int y, int w, int h,
			   HWND hWndParent, HINSTANCE,
			   char *name, size_t sz_name);

#endif
