#include "stdafx.h"
#include "embeded_tk.h"

char *script = " \
set root %s; \
frame $root.f ;\
button $root.b -command \"$root.b configure -text foo\" ;\
button $root.b2 -command \"$root.b2 configure -text foo2\" ;\
pack $root.b $root.b2 -side left -in $root.f -fill x -expand 1;\
canvas $root.c -bg white  ;\
pack $root.f  ;\
pack $root.c -fill both -expand 1 ;\
bind $root.c <ButtonPress-1> {draw %%W %%x %%y}; \
bind $root.c <ButtonPress-3> {del %%W %%x %%y}; \
proc draw { win x y } { \
    set x [$win canvasx $x] ;\
    set y [$win canvasy $y] ;\
    set x1 [expr $x - 10];\
    set y1 [expr $y - 10];\
    set x2 [expr $x + 20] ;\
    set y2 [expr $y + 20] ;\
    $win create oval $x1 $y1 $x2 $y2 -outline black -fill red ;\
} ;\
proc del { win x y } { \
    set x [$win canvasx $x] ;\
    set y [$win canvasy $y] ;\
    set x1 [expr $x - 1];\
    set y1 [expr $y - 1];\
    set x2 [expr $x + 2] ;\
    set y2 [expr $y + 2] ;\
    set l [$win find overlapping $x1 $y1 $x2 $y2] ;\
    foreach a $l { ;\
	set o [$win gettags $a] ;\
	    foreach b $o { ;\
		$win delete $b ;\
	    } ;\
    } ;\
} \
";

int APIENTRY WinMain(HINSTANCE hInstance,
		     HINSTANCE hPrevInstance,
		     LPSTR     lpCmdLine,
		     int       nCmdShow)
{
    Tcl_Interp *interp = Tcl_CreateInterp();
    EmbededTkInit(interp);

    char name[1024];
    char buf[10000];

    HWND h = CreateEmbededTkWindow(interp, WS_CLIPCHILDREN|WS_OVERLAPPEDWINDOW,
				    CW_USEDEFAULT, CW_USEDEFAULT,
				    400, 150, NULL, hInstance,
				    name, sizeof(name));
    ShowWindow(h, nCmdShow);
    UpdateWindow(h);

    sprintf(buf, script, name);
    if (Tcl_Eval(interp, buf) != TCL_OK) {
	printf("eval err %s\n", Tcl_GetStringResult(interp)); fflush(stdout);
	return 0;
    }

    h = CreateEmbededTkWindow(interp, WS_CLIPCHILDREN|WS_OVERLAPPEDWINDOW,
			      CW_USEDEFAULT, CW_USEDEFAULT,
			      400, 150, NULL, hInstance,
			      name, sizeof(name));
    ShowWindow(h, nCmdShow);
    UpdateWindow(h);

    sprintf(buf, script, name);
    if (Tcl_Eval(interp, buf) != TCL_OK) {
	printf("eval err %s\n", Tcl_GetStringResult(interp)); fflush(stdout);
	return 0;
    }

    MSG msg;
    while (GetMessage(&msg, NULL, 0, 0)) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    return msg.wParam;
}
